package com.zhentao.tool;

import com.zhentao.dto.VerifyDto;

import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Map;
import java.util.TreeMap;

public class VerifyUtil {
    public static Boolean verify(VerifyDto dto) throws NoSuchAlgorithmException {
//        ASSII 码排序
        Map<String,String> map = new TreeMap<>();
        map.put("appId",dto.getAppId());
        map.put("appSecret",dto.getAppSecret());
        map.put("reqId",dto.getReqId());
        map.put("reqTime",dto.getReTime());
        map.put("goodsId", dto.getGoodsId());
        StringBuilder sb = new StringBuilder();
        Boolean first = true;
        for (Map.Entry<String,String> entry :  map.entrySet()){
            if (first){
                sb.append(entry.getKey()).append("=").append(entry.getValue()).append("&");
                first=false;
            }else {
                sb.append("&").append(entry.getKey()).append("=").append(entry.getValue());
            }

        }
//        key = value&key=values最后在添加一个appSecret
        sb.append(dto.getAppSecret());
        System.err.println(sb);
//        MD5 加密
        try {
            String sign = EraHelper.byte2HexStr(MessageDigest.getInstance("MD5").digest(sb.toString().getBytes("UTF-8")));
            return sign.equals(dto.getSign());
        }catch (NoSuchAlgorithmException | UnsupportedEncodingException e){
            return false;
        }

    }
}
